package com.bergerkiller.bukkit.nolagg.sending;

import java.util.Collection;

import org.bukkit.block.BlockFace;

import net.minecraft.server.Chunk;
import net.minecraft.server.EntityPlayer;
import net.minecraft.server.Packet;
import net.minecraft.server.Packet53BlockChange;
import net.minecraft.server.TileEntity;

public class ChunkSendCommand implements Comparable<ChunkSendCommand> {
    public ChunkSendCommand(final BufferedPacket51MapChunk mapPacket, final Chunk chunk) {
        this.mapPacket = mapPacket;
        this.chunk = chunk;
    }
    private final BufferedPacket51MapChunk mapPacket;
    public final Chunk chunk; 
    public int index;
        
    public boolean isValid() {
    	return this.chunk != null && this.mapPacket != null;
    }
    
    public void send(final EntityPlayer receiver) {
    	send(receiver, this.mapPacket, this.chunk);
    }
    
    @SuppressWarnings("unchecked")
	public static void send(final EntityPlayer receiver, final BufferedPacket51MapChunk mapPacket, final Chunk chunk) {
    	receiver.netServerHandler.sendPacket(mapPacket);
    	Packet p;
    	for (TileEntity tile : (Collection<TileEntity>) chunk.tileEntities.values()) {
    		if ((p = tile.k()) != null) {
    			receiver.netServerHandler.sendPacket(p);
    		}
    	}
    	//send trigger
    	receiver.netServerHandler.sendPacket(new Packet53BlockChange(chunk.x << 4, 0, chunk.x << 4, chunk.world));
    }
    
	public void calculateIndex(final int midx, final int midz, final BlockFace direction) {
		this.index = ChunkCoordIndexer.get(this.chunk.x - midx, this.chunk.z - midz, direction);
	}
	public int compareTo(ChunkSendCommand ipair) {
		return this.index - ipair.index;
	}
}
