package com.bergerkiller.bukkit.nolagg.spawnlimit;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import net.minecraft.server.EntityFallingBlock;

import org.bukkit.Material;
import org.bukkit.craftbukkit.entity.CraftFallingSand;
import org.bukkit.entity.Entity;
import org.bukkit.entity.FallingSand;
import org.bukkit.entity.Item;
import org.bukkit.inventory.ItemStack;

public class WorldLimiter extends GroupLimiter {
	
	/*
	 * Entity limiters generated from group limiters
	 */
	private final Map<String, EntityLimiter> genEntities = new HashMap<String, EntityLimiter>();
	public EntityLimiter getEntityLimits(Entity entity) {
		if (entity instanceof Item) {
			return getEntityLimits(((Item) entity).getItemStack());
		} else if (entity instanceof FallingSand) {
			EntityFallingBlock fblock = ((CraftFallingSand) entity).getHandle();
			return getEntityLimits("falling" + Material.getMaterial(fblock.id).toString());
		} else {
			return getEntityLimits(entity.getClass().getSimpleName().substring(5));
		}
	}
	public EntityLimiter getEntityLimits(ItemStack item) {
		return getEntityLimits("item" + item.getType());
	}
	public EntityLimiter getEntityLimits(String name) {
		name = name.toLowerCase();
		if (name.contains("tnt")) name = "tnt";
		EntityLimiter lim = genEntities.get(name);
		if (lim == null) {
			lim = new EntityLimiter(name, SpawnHandler.GLOBAL, this);
			genEntities.put(name, lim);
		}
		return lim;
	}
	
	public void update(List<Entity> entities) {
		for (Entity e : entities) {
			if (SpawnHandler.isIgnored(e)) continue;
			if (!getEntityLimits(e).handleSpawn()) e.remove();
		}
	}
}
